"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = getBordersSize;

/*
 * Helper to detect borders of a given element
 * @method
 * @memberof Popper.Utils
 * @param {CSSStyleDeclaration} styles
 * Result of `getStyleComputedProperty` on the given element
 * @param {String} axis - `x` or `y`
 * @return {number} borders - The borders size of the given axis
 */
function getBordersSize(styles, axis) {
  var sideA = axis === 'x' ? 'Left' : 'Top';
  var sideB = sideA === 'Left' ? 'Right' : 'Bottom';
  return parseFloat(styles["border".concat(sideA, "Width")]) + parseFloat(styles["border".concat(sideB, "Width")]);
}

module.exports = exports.default;
//# sourceMappingURL=getBordersSize.js.map