"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = getStyleComputedProperty;

/**
 * Get CSS computed property of the given element
 * @method
 * @memberof Popper.Utils
 * @argument {Eement} element
 * @argument {String} property
 */
function getStyleComputedProperty(element, property) {
  if (element.nodeType !== 1) {
    return [];
  } // NOTE: 1 DOM access here


  var window = element.ownerDocument.defaultView;
  var css = window.getComputedStyle(element, null);
  return property ? css[property] : css;
}

module.exports = exports.default;
//# sourceMappingURL=getStyleComputedProperty.js.map